package com.company.resttokenenhancer.rest.configurer;

import com.company.resttokenenhancer.rest.enhancer.MyTokenEnhancer;
import io.jmix.core.session.SessionData;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.ObjectProvider;
import org.springframework.beans.factory.config.BeanPostProcessor;
import org.springframework.security.oauth2.provider.token.DefaultTokenServices;
import org.springframework.stereotype.Component;

@Component
public class MyBeanPostProcessor implements BeanPostProcessor {

    private ObjectProvider<SessionData> sessionsDataProvider;

    public MyBeanPostProcessor(ObjectProvider<SessionData> sessionsDataProvider) {
        this.sessionsDataProvider = sessionsDataProvider;
    }

    @Override
    public Object postProcessBeforeInitialization(Object bean, String beanName) throws BeansException {
        if (bean instanceof DefaultTokenServices) {
            ((DefaultTokenServices) bean).setTokenEnhancer(new MyTokenEnhancer(sessionsDataProvider));
        }
        return bean;
    }
}
