package com.company.resttokenenhancer.rest.enhancer;

import io.jmix.core.session.SessionData;
import io.jmix.securityoauth2.impl.SessionTokenEnhancer;
import org.springframework.beans.factory.ObjectProvider;
import org.springframework.security.oauth2.common.DefaultOAuth2AccessToken;
import org.springframework.security.oauth2.common.OAuth2AccessToken;
import org.springframework.security.oauth2.provider.OAuth2Authentication;

import java.util.HashMap;
import java.util.Map;

public class MyTokenEnhancer extends SessionTokenEnhancer {

    public MyTokenEnhancer(ObjectProvider<SessionData> sessionDataProvider) {
        super(sessionDataProvider);
    }

    @Override
    public OAuth2AccessToken enhance(OAuth2AccessToken accessToken, OAuth2Authentication authentication) {
        DefaultOAuth2AccessToken defaultAccessToken = (DefaultOAuth2AccessToken) super.enhance(accessToken, authentication);

        Map<String, Object> additionalInformation = new HashMap<>(accessToken.getAdditionalInformation());
        additionalInformation.put("my_attr", "my_value");

        defaultAccessToken.setAdditionalInformation(additionalInformation);
        return defaultAccessToken;
    }
}
